Loading...
Searching...
No Matches
ExtensionInfo Class Reference

ExtensionInfo contains information about extension. More...

`#include "factory/ExtensionInfo.h"`

## Public Member Functions

| ExtensionInfo (const bool extension)
| as initial field, if extension is true we are in some GF
| ExtensionInfo (const Variable &alpha, const Variable &beta, const CanonicalForm &gamma, const CanonicalForm &delta, const int nGFDegree, const char cGFName, const bool extension)
| Construct an ExtensionInfo.
| ExtensionInfo (const Variable &alpha, const Variable &beta, const CanonicalForm &gamma, const CanonicalForm &delta)
| as initial field and switch to an extension given by alpha, needs primitive elements gamma and delta for maps between
| ExtensionInfo (const Variable &alpha, const bool extension)
| as initial field, if extension is false. Else initial field is
| ExtensionInfo (const Variable &alpha)
| ExtensionInfo (const int nGFDegree, const char cGFName, const bool extension)
| GF as initial field.
Variable | getAlpha () const
| getter
Variable | getBeta () const
| getter
CanonicalForm | getGamma () const
| getter
CanonicalForm | getDelta () const
| getter
int | getGFDegree () const
| getter
char | getGFName () const
| getter
bool | isInExtension () const
| getter

## Private Attributes

Variable | m_alpha
| an algebraic variable or Variable (1)
Variable | m_beta
| an algebraic variable or Variable (1)
CanonicalForm | m_gamma
| a primitive element of or 1
CanonicalForm | m_delta
| a primitive element of or 1
int | m_GFDegree
| GF degree or 1.
char | m_GFName
| name of GF variable
bool | m_extension
| indicates if we are in an extension of some initial field

## Detailed Description

ExtensionInfo contains information about extension.

If m_extension is true we are in an extension of some initial field. If the initial field is and we pass to then m_alpha is an algebraic variable, m_beta= Variable(1), m_gamma= m_delta= 1, m_GFDegree= 0, m_GFName= 'Z'. If we pass to some GF (p^k) then m_alpha= Variable (1), m_beta= Variable(1), m_gamma= m_delta= 1, m_GFDegree= 1, m_GFName= 'Z'.
If the initial field is , then m_beta= , m_alpha an algebraic variable defining an extension of , m_gamma is a primitive element of , m_delta is a primitive element of , m_GFDegree= 0, m_GFName= 'Z'.
If the initial field is GF(p^k), then m_alpha= Variable (1), m_beta= Variable (1), m_gamma= 1, m_delta= 1, m_GFDegree()= k, m_GFName= gf_name of the initial field.
If m_extension is false and the current field is then m_alpha= Variable (1), m_beta= Variable (1), m_gamma= 1, m_delta= 1, m_GFDegree= 1, m_GFName= 'Z'.
If the current field is then m_alpha is some algebraic variable, m_beta= Variable (1), m_gamma= 1, m_delta= 1, m_GFDegree= 0, m_GFName= 'Z'.
If the current field is GF then m_alpha= Variable (1), m_beta= Variable (1), m_gamma= 1, m_delta= 1, m_GFDegree= getGFDegree(), m_GFName= gf_name.

See also
  facFqBivar.h, facFqFactorize.h

Definition at line 50 of file ExtensionInfo.h.

## Constructor & Destructor Documentation

## ExtensionInfo() [1/6]

ExtensionInfo::ExtensionInfo | ( | const bool | extension | ) |

as initial field, if extension is true we are in some GF

Parameters

  [in] | extension | some bool

Definition at line 19 of file ExtensionInfo.cc.

{
m_alpha= Variable (1);
m_beta= Variable (1);
m_gamma= CanonicalForm ();
m_delta= CanonicalForm ();
m_GFDegree= 1;
m_GFName= 'Z';
m_extension= extension;
}
ExtensionInfo::m_delta
CanonicalForm m_delta
a primitive element of or 1
Definition ExtensionInfo.h:60
ExtensionInfo::m_GFDegree
int m_GFDegree
GF degree or 1.
Definition ExtensionInfo.h:62
ExtensionInfo::m_extension
bool m_extension
indicates if we are in an extension of some initial field
Definition ExtensionInfo.h:66
ExtensionInfo::m_GFName
char m_GFName
name of GF variable
Definition ExtensionInfo.h:64
ExtensionInfo::m_beta
Variable m_beta
an algebraic variable or Variable (1)
Definition ExtensionInfo.h:56
ExtensionInfo::m_alpha
Variable m_alpha
an algebraic variable or Variable (1)
Definition ExtensionInfo.h:54
ExtensionInfo::m_gamma
CanonicalForm m_gamma
a primitive element of or 1
Definition ExtensionInfo.h:58

## ExtensionInfo() [2/6]

ExtensionInfo::ExtensionInfo | ( | const Variable & | alpha,
|  | const Variable & | beta,
|  | const CanonicalForm & | gamma,
|  | const CanonicalForm & | delta,
|  | const int | nGFDegree,
|  | const char | cGFName,
|  | const bool | extension )

Construct an ExtensionInfo.

Parameters

  [in] | alpha | some algebraic variable
  [in] | beta | some algebraic variable
  [in] | gamma | some primitive element of
  [in] | delta | some primitive element of
  [in] | nGFDegree | GFDegree of initial field
  [in] | cGFName | name of GF variable of initial field
  [in] | extension | some bool

Definition at line 30 of file ExtensionInfo.cc.

{
m_alpha= alpha;
m_beta= beta;
m_gamma= gamma;
m_delta= delta;
m_GFDegree= nGFDegree;
m_GFName= cGFName;
m_extension= extension;
}
alpha
Variable alpha
Definition facAbsBiFact.cc:52
beta
Variable beta
Definition facAbsFact.cc:95
CxxTest::delta
bool delta(X x, Y y, D d)
Definition TestSuite.h:160

## ExtensionInfo() [3/6]

ExtensionInfo::ExtensionInfo | ( | const Variable & | alpha,
|  | const Variable & | beta,
|  | const CanonicalForm & | gamma,
|  | const CanonicalForm & | delta )

as initial field and switch to an extension given by alpha, needs primitive elements gamma and delta for maps between

Parameters

  [in] | alpha | some algebraic variable
  [in] | beta | some algebraic variable
  [in] | gamma | some primitive element of
  [in] | delta | some primitive element of

Definition at line 44 of file ExtensionInfo.cc.

{
m_alpha= alpha;
m_beta= beta;
m_gamma= gamma;
m_delta= delta;
m_GFDegree= 0;
m_GFName= 'Z';
m_extension= true;
}

## ExtensionInfo() [4/6]

ExtensionInfo::ExtensionInfo | ( | const Variable & | alpha,
|  | const bool | extension )

as initial field, if extension is false. Else initial field is

Parameters

  [in] | alpha | some algebraic variable
  [in] | extension | some bool

Definition at line 57 of file ExtensionInfo.cc.

{
m_alpha= alpha;
m_beta= Variable (1);
m_gamma= CanonicalForm ();
m_delta= CanonicalForm ();
m_GFDegree= 0;
m_GFName= 'Z';
m_extension= extension;
}

## ExtensionInfo() [5/6]

ExtensionInfo::ExtensionInfo | ( | const Variable & | alpha | ) |

Parameters

  [in] | alpha | some algebraic variable

Definition at line 68 of file ExtensionInfo.cc.

{
m_alpha= alpha;
m_beta= Variable (1);
m_gamma= CanonicalForm ();
m_delta= CanonicalForm ();
m_GFDegree= 1;
m_GFName= 'Z';
m_extension= true;
}

## ExtensionInfo() [6/6]

ExtensionInfo::ExtensionInfo | ( | const int | nGFDegree,
|  | const char | cGFName,
|  | const bool | extension )

GF as initial field.

Parameters

  [in] | nGFDegree | GF degree of initial field
  [in] | cGFName | name of GF variable
  [in] | extension | some bool

Definition at line 79 of file ExtensionInfo.cc.

{
m_alpha= Variable (1);
m_beta= Variable (1);
m_gamma= CanonicalForm ();
m_delta= CanonicalForm ();
m_GFDegree= nGFDegree;
m_GFName= cGFName;
m_extension= extension;
}

## Member Function Documentation

## getAlpha()

Variable ExtensionInfo::getAlpha | ( |  | ) | const

inline

getter

Returns
  getAlpha() returns m_alpha

Definition at line 111 of file ExtensionInfo.h.

{
return m_alpha;
}

## getBeta()

Variable ExtensionInfo::getBeta | ( |  | ) | const

inline

getter

Returns
  getBeta() returns m_beta

Definition at line 118 of file ExtensionInfo.h.

{
return m_beta;
}

## getDelta()

CanonicalForm ExtensionInfo::getDelta | ( |  | ) | const

inline

getter

Returns
  getDelta() returns m_delta

Definition at line 132 of file ExtensionInfo.h.

{
return m_delta;
}

## getGamma()

CanonicalForm ExtensionInfo::getGamma | ( |  | ) | const

inline

getter

Returns
  getGamma() returns m_gamma

Definition at line 125 of file ExtensionInfo.h.

{
return m_gamma;
}

## getGFDegree()

int ExtensionInfo::getGFDegree | ( |  | ) | const

inline

getter

Returns
  getGFDegree() returns m_GFDegree

Definition at line 139 of file ExtensionInfo.h.

{
return m_GFDegree;
}

## getGFName()

char ExtensionInfo::getGFName | ( |  | ) | const

inline

getter

Returns
  getGFName() returns m_GFName

Definition at line 146 of file ExtensionInfo.h.

{
return m_GFName;
}

## isInExtension()

bool ExtensionInfo::isInExtension | ( |  | ) | const

inline

getter

Returns
  isInextension() returns m_extension

Definition at line 153 of file ExtensionInfo.h.

{
return m_extension;
}

## Field Documentation

## m_alpha

Variable ExtensionInfo::m_alpha

private

an algebraic variable or Variable (1)

Definition at line 54 of file ExtensionInfo.h.

## m_beta

Variable ExtensionInfo::m_beta

private

an algebraic variable or Variable (1)

Definition at line 56 of file ExtensionInfo.h.

## m_delta

CanonicalForm ExtensionInfo::m_delta

private

a primitive element of or 1

Definition at line 60 of file ExtensionInfo.h.

## m_extension

bool ExtensionInfo::m_extension

private

indicates if we are in an extension of some initial field

Definition at line 66 of file ExtensionInfo.h.

## m_gamma

CanonicalForm ExtensionInfo::m_gamma

private

a primitive element of or 1

Definition at line 58 of file ExtensionInfo.h.

## m_GFDegree

int ExtensionInfo::m_GFDegree

private

GF degree or 1.

Definition at line 62 of file ExtensionInfo.h.

## m_GFName

char ExtensionInfo::m_GFName

private

name of GF variable

Definition at line 64 of file ExtensionInfo.h.

The documentation for this class was generated from the following files:

- factory/ExtensionInfo.h
- factory/ExtensionInfo.cc